<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleGroupItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfVehicleGroupItem extends AbstractStructArrayBase
{
    /**
     * The VehicleGroupItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VehicleGroupItem[]
     */
    public $VehicleGroupItem;
    /**
     * Constructor method for ArrayOfVehicleGroupItem
     * @uses ArrayOfVehicleGroupItem::setVehicleGroupItem()
     * @param \StructType\VehicleGroupItem[] $vehicleGroupItem
     */
    public function __construct(array $vehicleGroupItem = array())
    {
        $this
            ->setVehicleGroupItem($vehicleGroupItem);
    }
    /**
     * Get VehicleGroupItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VehicleGroupItem[]|null
     */
    public function getVehicleGroupItem()
    {
        return isset($this->VehicleGroupItem) ? $this->VehicleGroupItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVehicleGroupItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVehicleGroupItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVehicleGroupItemForArrayConstraintsFromSetVehicleGroupItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVehicleGroupItemVehicleGroupItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleGroupItemVehicleGroupItemItem instanceof \StructType\VehicleGroupItem) {
                $invalidValues[] = is_object($arrayOfVehicleGroupItemVehicleGroupItemItem) ? get_class($arrayOfVehicleGroupItemVehicleGroupItemItem) : sprintf('%s(%s)', gettype($arrayOfVehicleGroupItemVehicleGroupItemItem), var_export($arrayOfVehicleGroupItemVehicleGroupItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VehicleGroupItem property can only contain items of type \StructType\VehicleGroupItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VehicleGroupItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleGroupItem[] $vehicleGroupItem
     * @return \ArrayType\ArrayOfVehicleGroupItem
     */
    public function setVehicleGroupItem(array $vehicleGroupItem = array())
    {
        // validation for constraint: array
        if ('' !== ($vehicleGroupItemArrayErrorMessage = self::validateVehicleGroupItemForArrayConstraintsFromSetVehicleGroupItem($vehicleGroupItem))) {
            throw new \InvalidArgumentException($vehicleGroupItemArrayErrorMessage, __LINE__);
        }
        if (is_null($vehicleGroupItem) || (is_array($vehicleGroupItem) && empty($vehicleGroupItem))) {
            unset($this->VehicleGroupItem);
        } else {
            $this->VehicleGroupItem = $vehicleGroupItem;
        }
        return $this;
    }
    /**
     * Add item to VehicleGroupItem value
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleGroupItem $item
     * @return \ArrayType\ArrayOfVehicleGroupItem
     */
    public function addToVehicleGroupItem(\StructType\VehicleGroupItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VehicleGroupItem) {
            throw new \InvalidArgumentException(sprintf('The VehicleGroupItem property can only contain items of type \StructType\VehicleGroupItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VehicleGroupItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\VehicleGroupItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\VehicleGroupItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\VehicleGroupItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\VehicleGroupItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\VehicleGroupItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VehicleGroupItem
     */
    public function getAttributeName()
    {
        return 'VehicleGroupItem';
    }
}
